/*
   16. April 2011
   
   1) Normale ungehedgte Trades
   2) Summarisch normale gehedgte Trades + Hedge-Trades
   3) Summarisch KompTrades (M1 + aktelles Timeframe)
   4) Summen aus 1+2+3
   (das ganze wie bereits von Ihnen vorgeschlagen x Anzahl, x Lots, x Betrag;

   neu:
      verbesserte Anzeige
      
   die Summe aller offenen Lots (Long/ Short)
   den aktuelle Wertverlust / Wertsteigerung (Summen) dieser Trades
   Die Lots / Summen die abgehedt / im Ausgleich Post Phase sind
   Die Lots / Summe die zum Ausgleich (Hedge bzw.Post Phase DynLot) mit DynLots gebraucht wrden...
   
   was wir also brauchen ist eine Anzeige Ges / normale offene Trades / gehegte Trades
   jeweils mit Anzahl / Lots / Betrag
   (alles getrennt nach Short / Long
   
   -> ad Anzeige:
   OK, sollen wir so machen:
   ... bisherige Anzeige...
   --------------------
   OpenLongNormal:   x trades, x lots, x profit
      also die LongTrades mit der normalen MagicNumber analysieren, die keinen Hedge haben
         GetCntNormal(OP_BUY), GetLotsNormal(OP_BUY), GetProfitNormal(OP_BUY)
            GetUnhedgedNormalTrades(OP_BUY)
   OpenLongGehedged: x trades, x lots, x profit
      also die LongTrades mit der normalen MagicNumber analysieren, die einen Hedge haben
   OpenLongGesamt:   x trades, x lots, x profit
      einfach alle LongTrades
   --------------------------------
   OpenShortNormal:   x trades, x lots, x profit
   OpenShortGehedged: x trades, x lots, x profit
   OpenShortGesamt:   x trades, x lots, x profit
 
   Anm: Geht vielleicht eine optische Aufarbeitung mit Bold, Tab, etc. dass man in der kommenden Menge an Zahlen nicht untergeht?
*/

string GetDisplayString()
{
   string dynLotsDisplay = GetDynLotsDisplayString();
   
   string dynLotsDisplayM1 = GetDynLotsDisplayStringBiggest();
   
   string openTradesDisplay = GetOpenTradesDisplayString();
   
   string s = dynLotsDisplay+"\n\n"+dynLotsDisplayM1+"\n\n"+openTradesDisplay;
   
   return(s);
}

string GetOpenTradesDisplayString()
{
   string curr = AccountCurrency();
   
   int cntUnhedgedL = GetCntUnhedgedTrades(OP_BUY);
   double lotsUnhedgedL = GetLotsUnhedgedTrades(OP_BUY);
   double profitUnhedgedL = GetProfitUnhedgedTrades(OP_BUY);
   
   int cntHedgedL = GetCntHedgedTrades(OP_BUY);
   double lotsHedgedL = GetLotsHedgedTrades(OP_BUY);
   double profitHedgedL = GetProfitHedgedTrades(OP_BUY);
   
   int cntHedgeL = GetCntHedgeTrades(OP_BUY);
   double lotsHedgeL = GetLotsHedgeTrades(OP_BUY);
   double profitHedgeL = GetProfitHedgeTrades(OP_BUY);
   
   int cntCompL = GetCntCompTrades(OP_BUY);
   double lotsCompL = GetLotsCompTrades(OP_BUY);
   double profitCompL = GetProfitCompTrades(OP_BUY);
   
   int cntUnhedgedS = GetCntUnhedgedTrades(OP_SELL);
   double lotsUnhedgedS = GetLotsUnhedgedTrades(OP_SELL);
   double profitUnhedgedS = GetProfitUnhedgedTrades(OP_SELL);
   
   int cntHedgeS = GetCntHedgeTrades(OP_SELL);
   double lotsHedgeS = GetLotsHedgeTrades(OP_SELL);
   double profitHedgeS = GetProfitHedgeTrades(OP_SELL);
   
   int cntHedgedS = GetCntHedgedTrades(OP_SELL);
   double lotsHedgedS = GetLotsHedgedTrades(OP_SELL);
   double profitHedgedS = GetProfitHedgedTrades(OP_SELL);
   
   int cntCompS = GetCntCompTrades(OP_SELL);
   double lotsCompS = GetLotsCompTrades(OP_SELL);
   double profitCompS = GetProfitCompTrades(OP_SELL);
   
   int cntAllL = cntUnhedgedL+cntHedgedL+cntHedgeS+cntCompL;
   double lotsAllL = lotsUnhedgedL+lotsHedgedL+lotsHedgeS+lotsCompL;
   double profitAllL = profitUnhedgedL+profitHedgedL+profitHedgeS+profitCompL;
   
   int cntAllS = cntUnhedgedS+cntHedgedS+cntHedgeL+cntCompS;
   double lotsAllS = lotsUnhedgedS+lotsHedgedS+lotsHedgeL+lotsCompS;
   double profitAllS = profitUnhedgedS+profitHedgedS+profitHedgeL+profitCompS;
   
   string unhedgedL = "UnhedgedLong: "+cntUnhedgedL+" trades,"+
      DoubleToStr(lotsUnhedgedL,2)+" lots,"+DoubleToStr(profitUnhedgedL,2)+" "+curr;
   string hedgedAndHedgeL = "HAndHLong:     "+(cntHedgedL+cntHedgeS)+" trades,"+
      DoubleToStr((lotsHedgedL+lotsHedgeS),2)+" lots,"+DoubleToStr((profitHedgedL+profitHedgeS),2)+" "+curr;
   string compL = "CompLong:       "+cntCompL+" trades,"+
      DoubleToStr(lotsCompL,2)+" lots,"+DoubleToStr(profitCompL,2)+" "+curr;
   string allL = "AllLong:            "+cntAllL+" trades,"+
      DoubleToStr(lotsAllL,2)+" lots,"+DoubleToStr(profitAllL,2)+" "+curr;
      
   string unhedgedS = "UnhedgedShort: "+cntUnhedgedS+" trades,"+
      DoubleToStr(lotsUnhedgedS,2)+" lots,"+DoubleToStr(profitUnhedgedS,2)+" "+curr;
   string hedgedAndHedgeS = "HAndHShort:     "+(cntHedgedS+cntHedgeL)+" trades,"+
      DoubleToStr((lotsHedgedS+lotsHedgeL),2)+" lots,"+DoubleToStr((profitHedgedS+profitHedgeL),2)+" "+curr;
   string compS = "CompShort:       "+cntCompS+" trades,"+
      DoubleToStr(lotsCompS,2)+" lots,"+DoubleToStr(profitCompS,2)+" "+curr;
   string allS = "AllShort:            "+cntAllS+" trades,"+
      DoubleToStr(lotsAllS,2)+" lots,"+DoubleToStr(profitAllS,2)+" "+curr;
   
   string openTradesDisplay = "OPEN TRADES\n----------------------------\n"+unhedgedL+"\n"+hedgedAndHedgeL+"\n"+compL+"\n"+allL+"\n----------------------------\n"+
      unhedgedS+"\n"+hedgedAndHedgeS+"\n"+compS+"\n"+allS;
   
   return(openTradesDisplay);
}

int GetUnhedgedTrades(int& tickets[], int cmd)
{
   ArrayResize(tickets, 0);
   
   int cnt = FillArrWithTickets(tickets, MagicNumber, Symbol(), cmd, MODE_TRADES);
   
   for(int i=cnt-1; i >= 0; i--)
   {
      int ticket = tickets[i];
      
      if(IsHedged(ticket))
         IntDelElement(tickets, i);
   }
   
   cnt = ArraySize(tickets);
   
   return(cnt);
}

int GetCntUnhedgedTrades(int cmd)
{
   int tickets[];
   return(GetUnhedgedTrades(tickets, cmd));
}

double GetLotsUnhedgedTrades(int cmd)
{
   int tickets[];
   int cnt = GetUnhedgedTrades(tickets, cmd);
   
   double lots = GetLotsFromArray(tickets);
   
   return(lots);
}

double GetProfitUnhedgedTrades(int cmd)
{
   int tickets[];
   int cnt = GetUnhedgedTrades(tickets, cmd);
   
   double profit = GetProfitFromArray(tickets, MODE_ACCOUNT_CURRENCY);
   
   return(profit);
}

int GetCompTrades(int& tickets[], int cmd)
{
   ArrayResize(tickets, 0);
   int tickets1[];
   
   FillArrWithTickets(tickets, MagicNumberCompensatory, Symbol(), cmd, MODE_TRADES);
   FillArrWithTickets(tickets1, MagicNumberCompensatoryM1, Symbol(), cmd, MODE_TRADES);
   
   int cnt = IntAddIntArr(tickets, tickets1);
   
   return(cnt);
}

int GetCntCompTrades(int cmd)
{
   int tickets[];
   return(GetCompTrades(tickets, cmd));
}

double GetLotsCompTrades(int cmd)
{
   int tickets[];
   int cnt = GetCompTrades(tickets, cmd);
   
   double lots = GetLotsFromArray(tickets);
   
   return(lots);
}

double GetProfitCompTrades(int cmd)
{
   int tickets[];
   int cnt = GetCompTrades(tickets, cmd);
   
   double profit = GetProfitFromArray(tickets, MODE_ACCOUNT_CURRENCY);
   
   return(profit);
}

int GetHedgeTrades(int& tickets[], int cmd)
{
   ArrayResize(tickets, 0);
   
   int cnt = FillArrWithTickets(tickets, MagicNumberHedge, Symbol(), cmd, MODE_TRADES);
   
   return(cnt);
}

int GetCntHedgeTrades(int cmd)
{
   int tickets[];
   return(GetHedgeTrades(tickets, cmd));
}

double GetLotsHedgeTrades(int cmd)
{
   int tickets[];
   int cnt = GetHedgeTrades(tickets, cmd);
   
   double lots = GetLotsFromArray(tickets);
   
   return(lots);
}

double GetProfitHedgeTrades(int cmd)
{
   int tickets[];
   int cnt = GetHedgeTrades(tickets, cmd);
   
   double profit = GetProfitFromArray(tickets, MODE_ACCOUNT_CURRENCY);
   
   return(profit);
}

int GetHedgedTrades(int& tickets[], int cmd)
{
   ArrayResize(tickets, 0);
   
   int cnt = FillArrWithTickets(tickets, MagicNumber, Symbol(), cmd, MODE_TRADES);
   
   for(int i=cnt-1; i >= 0; i--)
   {
      int ticket = tickets[i];
      
      if(!IsHedged(ticket))
         IntDelElement(tickets, i);
   }
   
   cnt = ArraySize(tickets);
   
   return(cnt);
}

int GetCntHedgedTrades(int cmd)
{
   int tickets[];
   return(GetHedgedTrades(tickets, cmd));
}

double GetLotsHedgedTrades(int cmd)
{
   int tickets[];
   int cnt = GetHedgedTrades(tickets, cmd);
   
   double lots = GetLotsFromArray(tickets);
   
   return(lots);
}

double GetProfitHedgedTrades(int cmd)
{
   int tickets[];
   int cnt = GetHedgedTrades(tickets, cmd);
   
   double profit = GetProfitFromArray(tickets, MODE_ACCOUNT_CURRENCY);
   
   return(profit);
}

/*
   Welche sollen hier einbezogen werden?

int GetAllTrades(int& tickets[], int cmd)
{
   ArrayResize(tickets, 0);
   
   int cntNormal = FillArrWithTickets(tickets, MagicNumber, Symbol(), cmd, MODE_TRADES);
   int cntHedge = FillArrWithTickets(tickets, MagicNumberHedge, Symbol(), cmd, MODE_TRADES);
   
   cnt = cntNormal+cntHedge;
   
   return(cnt);
}

int GetCntAllTrades(int cmd)
{
   int tickets[];
   return(GetAllTrades(tickets, cmd));
}

double GetLotsAllTrades(int cmd)
{
   int tickets[];
   int cnt = GetAllTrades(tickets, cmd);
   
   double lots = GetLotsFromArray(tickets);
   
   return(lots);
}

double GetProfitAllTrades(int cmd)
{
   int tickets[];
   int cnt = GetAllTrades(tickets, cmd);
   
   double profit = GetProfitFromArray(tickets, MODE_ACC
   
   return(profit);
}*/

string GetDynLotsDisplayString()
{
   string sLong = "LONG: no open trades", 
      sShort = "SHORT: no open trades";
   
   int tradesCountContainerLong, tradesCountContainerShort;
   double curProfitContainerLong, curProfitContainerShort;
   double dynLotsLong = GetDynLots(OP_BUY, TimeCurrent()+1, tradesCountContainerLong, curProfitContainerLong);
   double dynLotsShort = GetDynLots(OP_SELL, TimeCurrent()+1, tradesCountContainerShort, curProfitContainerShort);
   
   if(dynLotsLong > 0)
   {
      sLong = "LONG current profit: "+DoubleToStr(curProfitContainerLong, 2)+
         " compensating with "+DoubleToStr(dynLotsLong, 2)+" lots";
   }
   if(dynLotsShort > 0)
   {
      sShort = "SHORT current profit: "+DoubleToStr(curProfitContainerShort, 2)+
         " compensating with "+DoubleToStr(dynLotsShort, 2)+" lots";
   }
   
   string s = sLong+"\n"+sShort;
   
   return(s);
}

string GetDynLotsDisplayStringBiggest()
{
   string sLong = "LONG: no open trades", 
      sShort = "SHORT: no open trades";
   
   int loserTicketL, loserTicketS;
   double dynLotsLong = GetBiggestLoserCompLots(OP_BUY, loserTicketL);
   double dynLotsShort = GetBiggestLoserCompLots(OP_SELL, loserTicketS);
   
   double biggestLossL = GetTradesProfitInAccCurr(loserTicketL);
   double biggestLossS = GetTradesProfitInAccCurr(loserTicketS);
   
   sLong = "LONG max loss: "+DoubleToStr(biggestLossL, 2)+
      " compensating with "+DoubleToStr(dynLotsLong, 2)+" lots";
         
   sShort = "SHORT max loss: "+DoubleToStr(biggestLossS, 2)+
      " compensating with "+DoubleToStr(dynLotsShort, 2)+" lots";
   
   string s = sLong+"\n"+sShort;
   
   return(s);
}