//+------------------------------------------------------------------+
//|   adds value to double array[], returns new size
//+------------------------------------------------------------------+
int DoubleAdd(double& array[], double value)
{
   string f = StringConcatenate("DoubleAdd(value=",value);

 //creates space for this new element
   int newFirstDimLen = DoubleEnlarge(array, 1);
   
   array[newFirstDimLen-1] = value;
   
   return(newFirstDimLen);
}

string MyDoubleToStr(double d, int precision = -1, string decimalSep = ".")
{
   string f = "MyDoubleToStr(d="+d+" precision="+precision+" decimalSep="+decimalSep+")";
   string s;
   
   if(precision >= 0)
      s = DoubleToStr(d, precision);
   else
      s = d;
      
   Debug(f, "s= \'"+s+"\'");
      
   if(decimalSep != ".")
      s = StrReplace(s, ".", decimalSep);
      
   Debug(f, "s= \'"+s+"\'");
      
   return(s);
}

//+------------------------------------------------------------------+
//|     this enlarges / resizes the passed array's first dimension   |
//+------------------------------------------------------------------+
//|   inputs:
//|      double& array[]   reference of the array we wanna enlarge
//|      int byHowMuch     by how much we wanna enlarge the array, defaults to 1
//+------------------------------------------------------------------+
//|   return:
//|      int      new size of array
//+------------------------------------------------------------------+
int DoubleEnlarge(double& array[], double byHowMuch = 1)
{
   string f = StringConcatenate("DoubleEnlarge(byHowMuch=",byHowMuch);
   
 //gets the old size
   int oldSize = ArrayRange(array, 0);
   int newSize = (oldSize+byHowMuch);
   
   //Debug(f, StringConcatenate("enlarging int array[] from ",oldSize," to ",newSize));
   
 //increases the 1st dimension by the given number
   ArrayResize(array,newSize);
   
 //returns the new size of the 1st dimension
   return(newSize);
}


