
int IntMinus(int a1[], int a2[], int& result[])
{
   ArrayResize(result, 0);
   
   if(ArraySize(a1) <= 0)
      return;
   
   int size2 = ArraySize(a2);
   for(int i=0; i < size2; i++)
   {
      IntDelValue(a1, a2[i]);
   }
   
   ArrayResize(result, ArraySize(a1));
   
   if(ArraySize(a1) > 0)
      ArrayCopy(result, a1);
   
   return(ArraySize(result));
}

int IntAddIntArr(int& a1[], int a2[]) {
   string f = "IntAddArr";
   
   for(int i=0; i < ArraySize(a2); i++) {
      IntAdd(a1, a2[i]);
   }
   
   return(ArraySize(a1));
}

int IntDelElement(int& a[], int index)
{
   int oldSize = ArraySize(a);
   
 //moves all elements following index one up to overwrite the value @i=index
 //but this swapping is only done if ArraySize > 1, otherwise we get an OutOfBoundsError
   for(int i=index; i < (ArraySize(a)-1); i ++)
      a[i] = a[i+1];
      
 //since the array became smaller we gott resize it
   return(ArrayResize(a, oldSize-1));
}

//+------------------------------------------------------------------+
//|   finds occurrances of given value in array, deletes 
//|   corresponding elements and returns new size of resized array
//+------------------------------------------------------------------+
int IntDelValue(int& array[], int value)
{
   string f = "IntDelValue";
   
   /*Debug(f, StringConcatenate("** started with input **:\n  value=",
      value,"\n\n", IntGetLogStr(array, "array before \'search and destroy\'")));*/
      
 //while there're still integers of the given values in the array
   int occurrences = 0;
   while(!IsStopped())
   {
      if(occurrences >= 999)
      {
         //Warn(f, "found >= 999 occurrences, cannot be right, exiting...");
         return(-1);
      }
      
    //save the index where the given value is found at
      int foundAt = IntGetIndex(array, value);
   
    //if the int has been found
      if(foundAt >= 0)
      {
         /*Debug(f, StringConcatenate("found value at index=",foundAt,", this occurance ",
            occurrences,". Gonna delete it"));*/
            
         int newSize = IntDelElement(array, foundAt);
      
         if(newSize >= 0)
         {
            //Debug(f, StringConcatenate("apparently successfully deleted array[",foundAt,"]"));
         }
         else
         {
            //Error(f, "couldn\'t delete entry, see logs, returning -1");
            return(-1);
         }
      }
    //mostly the function exits here since here 
      else
      {
       //the value hasn't been found and therefore not deleted
         /*Debug(f, StringConcatenate("couldn\'t find specified value in array after ",
            occurrences," occurrences, returning newSize=",newSize));*/
            
       //the last result from IntSortDel should be the new size
         return(newSize);
      }
      
      occurrences++;
   }
   
 //the last result from IntSortDel should be the new size
 //however, we only arrive here if IsStopped()=true
   return(newSize);
}

//+------------------------------------------------------------------+
//|   returns the index of the first occurrance of the passed int 
//|   within the passed array of ints, it's like a search
//+------------------------------------------------------------------+
int IntGetIndex(int haystack[], int needle)
{
   string f = "IntGetIndex";
   
   /*Debug(f, StringConcatenate("** started with inputs: **\n  needle=",needle,
      "\n\n"+IntGetLogStr(haystack, "array to be searched")));*/
   
 //for each element of the array
   for(int i=0; i<ArraySize(haystack); i++)
   {
    //if the current element equals the passed needle
      if(haystack[i] == needle)
      {
       //now exit and return the index
         //Debug(f, StringConcatenate("value found at index i=",i," returning it"));
         
         return(i);
      }
   }  
   
 //since this is a very secure and thoroughly testes function we don't need logging
 //better make the function up in the hierachy take care of appropriate logging
   //Debug(f, "couldn\'t find value in array, returning -1");
   
   return(-1);
}
//+------------------------------------------------------------------+
//|     this enlarges / resizes the passed array's first dimension   |
//+------------------------------------------------------------------+
//|   inputs:
//|      double& array[]   reference of the array we wanna enlarge
//|      int byHowMuch     by how much we wanna enlarge the array, defaults to 1
//+------------------------------------------------------------------+
//|   return:
//|      int      new size of array
//+------------------------------------------------------------------+
int IntEnlarge(int& array[], int byHowMuch = 1)
{
   string f = StringConcatenate("IntEnlarge(byHowMuch=",byHowMuch,")");
   
 //gets the old size
   int oldSize = ArrayRange(array, 0);
   int newSize = (oldSize+byHowMuch);
   
   //Debug(f, StringConcatenate("enlarging int array[] from ",oldSize," to ",newSize));
   
 //increases the 1st dimension by the given number
   ArrayResize(array,newSize);
   
 //returns the new size of the 1st dimension
   return(newSize);
}

//+------------------------------------------------------------------+
//|   adds value to integer array[], returns new size
//+------------------------------------------------------------------+
int IntAdd(int& array[], int value)
{
   string f = "IntAdd";

 //that certainly is too much logging
   /*Info(f, "** starting with inputs: **\n  value="+value);
   Info(f, IntGetLogStr(array, "contents of array before adding value"));*/
   
 //creates space for this new element
   int newFirstDimLen = IntEnlarge(array, 1);
   
   array[newFirstDimLen-1] = value;
   
   //Info(f, IntGetLogStr(array, "contents of array after adding value, newSize="+newFirstDimLen));
   
   return(newFirstDimLen);
}