
void InitTradesFund()
{
   ArrayResize(RecordedInFund, 0);
   
   TradesFundVarName = MagicNumber+"_"+Symbol()+"_TradeFund";
   
   if(!GlobalVariableCheck(TradesFundVarName))
   {
      GlobalVariableSet(TradesFundVarName, 0);
   }
}

double GetTradeFund()
{
   return(GlobalVariableGet(TradesFundVarName));
}

double SetTradeFund(double amount)
{
   Print("setting Trades\' Fund Amount from: "+
      DoubleToStr(GetTradeFund(),2)+" to: "+DoubleToStr(amount,2));
   
   return(GlobalVariableSet(TradesFundVarName, amount));
}

/*
UMSETZUNG
   
   phasenbergreifende Ausgleichskasse wird erstellt
   Die Kasse muss als glob.Var gespeichert werden
   jede Position, die geschlossen wird, muss in die Kasse genommen werden
   damit nicht mehrmals die gleiche berechnet wird, merken wir uns die Schlusszeit des Trades und addieren
      dann nur alle, die danach geschlossen wurden. Diese Var. wird bei Start mit aktueller Zeit initialisiert
   es wird dann laufend abgefragt, ob gilt Ausgleichskasse >= Verlust des verlustreichsten Trades,
      der gegen diese aktuelle Phase ist.
   Wenn ja, dann wird dieser Short geschlossen und der Betrag von der Kasse abgezogen.
*/
void ManageTradeFund()
{
   int closedTickets[], resultTickets[], notRecorded[];
   FillArrWithTickets(closedTickets, MagicNumber, Symbol(), MODE_MARKET, MODE_HISTORY);
   
   int mostRecentClosedTicket = GetMostRecentCloseTrade(closedTickets);
   
   /*if(mostRecentClosedTicket > 0 && Hour()==8 && Minute() == 50)
      Print("mostRecentClosedTicket="+mostRecentClosedTicket);*/
   
   if(!OrderSelect(mostRecentClosedTicket,SELECT_BY_TICKET))
      return;
      
   datetime lastClosedOrdersTime = OrderCloseTime();
   
   int count = GetTradesClosedSince(closedTickets, resultTickets, LastCloseTime-1);
   count = IntMinus(resultTickets, RecordedInFund, notRecorded);
   
   if(count <= 0)
      return;
   
   Print("recording "+count+" closed trades\' profit in fund...");
   
   double oldAmount = GetTradeFund(), profit = 0;
   for(int i=0; i < count; i++)
   {
      int ticket = notRecorded[i];
      
      profit += GetTradesProfit(ticket);
      
      IntAdd(RecordedInFund, ticket);
   }
   
   //Print("oldAmount="+oldAmount+" profit"+profit+" lastClosedOrdersTime="+TimeToStr(lastClosedOrdersTime));
   
   double newAmount = oldAmount+profit;
   
   SetTradeFund(newAmount);
   
   LastCloseTime = lastClosedOrdersTime;
}

void CloseTradesByFundByNextPhase()
{
   while(!IsStopped())
   {
      int tickets[];
      ArrayResize(tickets, 0);
      
      int cmd = -1;
      if(CurPhase == MODE_LONG)
         cmd = MODE_MARKET_SHORT;
      else if(CurPhase == MODE_SHORT)
         cmd = MODE_MARKET_LONG;
         
      if(cmd > -1)  
      {
         FillArrWithTickets(tickets, MagicNumber, Symbol(), cmd, MODE_TRADES);
      }
      
      int ticket = GetBiggestLoser(tickets);
   
      if(ticket <= 0)
         break;
      
      double profit = GetTradesProfit(ticket);
      double fund = GetTradeFund();
      
      if(fund >= -profit)
      {
         Print("current biggest loser T#"+ticket+" with profit="+profit+" can be closed by fund="+fund);
         
         CloseOrder(ticket);
         
         /*Print("subtracting profit="+profit+" from fund...");
         
         SetTradeFund(fund+profit);*/
         
         ManageTradeFund();
      }
      else
         break;
   }
}

