
void ReactOnPhaseChange(int lastPhase, int curPhase)
{
   Print("=========== General Phase Change from "+lastPhase+" to "+curPhase+" (LONG = "+
      OP_BUY+", SHORT = "+OP_SELL+") ===========");
      
   if(VisualizeGeneralTradePhases)
      DrawPhaseLine(curPhase);

   OpenDynLotsTrade(curPhase);
   
   if(CloseTradesOnPhaseChange)
      CloseTradesOnPhaseChange();
   
   if(UseStaticCompTrade)
      OpenStaticKompTrade(curPhase);
}

void ReactOnPhaseChange_x(int lastPhase_x, int curPhase_x)
{
   Print("=========== M1-Phase Change from "+lastPhase_x+" to "+curPhase_x+" (LONG = "+
      OP_BUY+", SHORT = "+OP_SELL+") ===========");
      
   if(VisualizeM1TradePhases)
      DrawPhaseArrow(curPhase_x);

   if(curPhase_x >= 0)
   {
      if(UseM1Hedging)
      {
         OpenDynLotsTrade_x(curPhase_x);
               
         OpenHedgeOnPhaseChange_x(curPhase_x);
      }
      
      if(UseStaticCompTradeM1)
      {
         if(!NewCompTradeRestricted(curPhase_x))
            OpenStaticKompTrade_x(curPhase_x);
      }
   }
}

void CloseTradesOnPhaseChange()
{
   int tempTickets[], tempTicketsH[];
   int ticketCount = FillArrWithTickets(tempTickets, MagicNumber, Symbol(), MODE_ALL, MODE_TRADES);
   int ticketCountH = FillArrWithTickets(tempTicketsH, MagicNumberHedge, Symbol(), MODE_ALL, MODE_TRADES);
  
   ticketCount = IntAddIntArr(tempTickets, tempTicketsH);
   
   CloseOrders(tempTickets);
}