
int OpenCompensatoryTrade(int cmd, double lots, int magic, int slPoints = 0, int tpPoints = 0, int compForTicket=-1)
{
   double openPrice = GetOpenPriceForCmd(Symbol(), cmd);
   
   color clr = CLR_NONE;
   
   if(cmd == OP_BUY)
      clr = CLR_OPEN_COMP_LONG;
   else if(cmd == OP_SELL)
      clr = CLR_OPEN_COMP_SHORT;
      
   double sl = GetSLForCmd(Symbol(), cmd, slPoints, openPrice);
   double tp = GetTPForCmd(Symbol(), cmd, tpPoints, openPrice);
   
   string comment = "Comp";   
   if(compForTicket > 0)
      comment = "C#"+compForTicket;
   
   int ticket = OrderSend(Symbol(), cmd, lots, openPrice, Slippage, sl, tp, comment, magic, 0, clr);
   
   return(ticket);
}

void CloseOrders(int tickets[])
{
   for(int i=0; i < ArraySize(tickets); i++)
      CloseOrder(tickets[i]);
}

bool ModifyTakeProfit(int ticket, double newTakeProfit)
{
   string f = "ModifyTakeProfit(ticket="+ticket+" newTakeProfit="+newTakeProfit+")";
   
   if(!OrderSelect(ticket, SELECT_BY_TICKET))
      return;
      
   //Debug(f, "modifying TP...");
   
   double oldTP = NormalizeDouble(OrderTakeProfit(), Digits);
   newTakeProfit = NormalizeDouble(newTakeProfit, Digits);
   
   if(oldTP == newTakeProfit)
      return;
   
   bool res = OrderModify(ticket, OrderOpenPrice(), OrderStopLoss(), newTakeProfit, OrderExpiration(), CLR_MODIFY);
   
   return(res);
}

void ModifyTakeProfits(int tickets[], double newTakeProfit)
{
   for(int i=0; i < ArraySize(tickets); i++)
      ModifyTakeProfit(tickets[i], newTakeProfit);
}

bool CloseOrder(int ticket)
{
   if(!OrderSelect(ticket, SELECT_BY_TICKET))
      return(false);
   
   int cmd = OrderType();
   double oLots = OrderLots();
   double closePrice = GetClosePriceForCmd(OrderSymbol(), cmd);
   //color clr = GetColorForCmd(cmd);
   color clr = Yellow;
   
   bool res = OrderClose(ticket, oLots, closePrice, Slippage, clr);
   
   return(res);
}

