
void DoTrailing()
{
   int tickets[];
   
   FillArrWithTickets(tickets, MagicNumber, Symbol());
   
   int BreakEven = 0;
   
   Trailing(tickets, TrailingAct, TrailingStep, TrailingDist, BreakEven);
}

void Trailing(int tickets[], int trailingAct, int trailingStep, int trailingStop, int moveToBE)
{
   string f = "Trailing";
   
   /*Debug(f, StringConcatenate("started with inputs: act: ", trailingAct, " step: ", 
      trailingStep, ", stop: ",trailingStop,", BE: ", moveToBE));*/
      
   for(int i=0; i < ArraySize(tickets); i++)
   {
      int ticket = tickets[i];
      //Print("trailing T#",ticket);
      
    //selects the order, on error: logging
      if(!OrderSelect(ticket, SELECT_BY_TICKET))
      {
         //Warn(f, "error while selecting order in TrailingMoveBE()");
         return;
      }
   
    //refresh the constant like Digits, Ask...
      RefreshRates();
  
    //get the data for this certain symbol and not for the one which the Script is attached to
      double bid = MarketInfo(OrderSymbol(), MODE_BID);
      double ask = MarketInfo(OrderSymbol(), MODE_ASK);
      double digits = MarketInfo(OrderSymbol(), MODE_DIGITS);
      double point = MarketInfo(OrderSymbol(), MODE_POINT);
   
    //assign values
      double trailedPriceLong = NormalizeDouble((bid-point*trailingStop), digits);
      double trailedPriceShort = NormalizeDouble((ask+point*trailingStop), digits);
   
      /*Debug(f, StringConcatenate("OCT=",OrderCloseTime(),", OType=",OrderType(),
         " bid=",bid,", ask=",ask,", digits=",digits,", point=",
         point,", trailedPriceLong=",trailedPriceLong,", trailedPriceShort=",trailedPriceShort));*/
   
    //if the position if closed or pending whatev, at least not open BUY or SELL
      if(OrderCloseTime() != 0 || (OrderType() != OP_BUY && OrderType() != OP_SELL))
         return;
    
      double profit, priceBE;
      double currentStop = NormalizeDouble(OrderStopLoss(), digits);
      
      //Debug(f, StringConcatenate("currentStop=",currentStop));
         
    //if it's a long position
      if(OrderType() == OP_BUY)
      {
         profit = (NormalizeDouble((bid - OrderOpenPrice()), digits))/point;  // calculates the profit in pips
         priceBE = NormalizeDouble(OrderOpenPrice(), digits);   // the BreakEven price
         
         //Debug(f, StringConcatenate("determined profit=",profit,", priceBE=",priceBE));
      
       //---- TRAILING STOP ----//
       //if the T/S is enabled
         if(trailingStop > 0 &&
          //if we are 'TrailingAct' or higer in Profit and stop is lower than the trailing price
            profit >= trailingAct && currentStop < trailedPriceLong)
         {
          //if S/L is lower than Bid-(TrailingStep-T/S) (necessary for the step-like behavior)
            if(currentStop <= NormalizeDouble(bid-point*(trailingStep+trailingStop), digits))
            {
               /*if(!OrderModify(ticket, 0, trailedPriceLong, OrderTakeProfit(), 0, CLR_TRAILING))
                  Error(f, StringConcatenate("error while trailing stop in ",
                     "TrailingMoveBE(), last err: ", MyOrderLastErrTxt()));*/
               OrderModify(ticket, 0, trailedPriceLong, OrderTakeProfit(), 0, CLR_TRAILING);
            }
         }
      }
    //if the position is short
      else if(OrderType() == OP_SELL)
      {
         profit = (NormalizeDouble((OrderOpenPrice() - ask), digits))/point;  // calculates the profit in pips
         priceBE = NormalizeDouble(OrderOpenPrice(), digits);   // the BreakEven price
         
         if(currentStop == 0)  // if the stop nis not set it's zero which is causing problems with the following logic
            currentStop = 10000; // requests like 'currentstop > priceBE' don't work if it's 0, now it works for stop which are 0
      
         //Debug(f, StringConcatenate("determined profit=",profit,", priceBE=",priceBE));
      
       //---- TRAILING STOP ----//
       //if the T/S is enabled
         if(trailingStop > 0 &&
          //if we are 'TrailingAct' or higer in Profit and stop is higher than the trailing price
            profit >= trailingAct && currentStop > trailedPriceShort)
         {
          //if S/L is higher than Bid-(TrailingStep-T/S) (necessary for the step-like behavior)
            if(currentStop >= NormalizeDouble(ask+point*(trailingStep+trailingStop), digits))
            {
               /*if(!OrderModify(OrderTicket(), 0, trailedPriceShort, OrderTakeProfit(), 0, CLR_TRAILING))
                  Error(f, StringConcatenate("error while trailing stop in ",
                     "TrailingMoveBE(), last err: ", MyOrderLastErrTxt()));*/
               OrderModify(OrderTicket(), 0, trailedPriceShort, OrderTakeProfit(), 0, CLR_TRAILING);
            }
         }
      }
   }
   return;
}

